/***************************************************************************
 *   Copyright (C) 2004 by Rick L. Vinyard, Jr.                            *
 *   rvinyard@cs.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/

#ifndef PAPYRUS_FACTORY_H
#define PAPYRUS_FACTORY_H

#include <papyrus.h>

namespace Papyrus {

typedef enum DRAWABLE {
  DRAWABLE_START=0,
  ARC=0,
  BEZIERLINE,
  BEZIERGON,
  BOXED,
  CIRCLE,
  FACE,
  GRID,
  GROUP,
  HANDLEBOX,
  HILBERT,
  IMAGE,
  KOCHCURVE,
  KOCHSNOWFLAKE,
  POLYGON,
  POLYLINE,
  RECTANGLE,
  REGULARPOLYGON,
  SIERPINSKI,
  TEXT,
  DRAWABLE_END,
} DRAWABLE;

extern char* DrawableStrings[];

Drawable::pointer example_factory( unsigned int d, bool fill=true, bool outline=false );

Arc::pointer        example_arc(bool fill=true, bool outline=false);
Bezierline::pointer example_bezierline(bool fill=false, bool outline=false);
Beziergon::pointer  example_beziergon(bool fill=false, bool outline=false);
Boxed::pointer      example_boxed(bool fill=false, bool outline=true);
Circle::pointer     example_circle(bool fill=true, bool outline=false);
Group::pointer      example_group(bool fill=true, bool outline=false);
Handlebox::pointer  example_handlebox(bool fill=true, bool outline=false);
Image::pointer      example_image(bool, bool);
Rectangle::pointer  example_rectangle(bool fill=true, bool outline=false);

Group::pointer  example_line_join( Cairo::LineJoin line_join );
Group::pointer  example_line_cap( Cairo::LineCap line_cap );
Polyline::pointer  example_marker( Papyrus::Marker::STYLE style, Papyrus::Marker::FACING facing, bool fill=false, bool outline = true);

}

#endif
