/***************************************************************************
 *   Copyright (C) 2006 by Rick L. Vinyard, Jr.                            *
 *   rvinyard.nmsu.edu                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Lesser General Public License as        *
 *   published by the Free Software Foundation version 2.1.                *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the                 *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA              *
 ***************************************************************************/
#include "x11_color.h"

#include <papyrus/rgba.h>

namespace Papyrus
{

  void x11_colors_1( X11Colors& colors );
  void x11_colors_2( X11Colors& colors );
  void x11_colors_3( X11Colors& colors );
  void x11_colors_4( X11Colors& colors );

  X11Colors x11_colors( )
  {
    X11Colors colors;

    x11_colors_1( colors );
    x11_colors_2( colors );
    x11_colors_3( colors );
    x11_colors_4( colors );

    return colors;
  }

  RGBA x11_color( const std::string& name ) {
    static X11Colors colors = x11_colors();
    X11Colors::iterator i;
    i = colors.find(name);
    if ( i != colors.end() )
      return i->second;
    else
      return RGBA();
  }

}
